# Formatting changes made to the Word file copied from the PDF of the Segments Dictionary:
# 1)  The description (the line after the segment ID line), the list of segments used in, and 
#     the list of transaction sets are changed to a single paragraph (single line when 
#     converted to a text file).
# 2)  Component elements (data elments comprising the segment) are changed to a single paragraph 
#     (single line when converted to a text file).
# 3)  Each segment definition separated from the next by a blank paragraph (line in text file).
# 4)  "Syntax Notes", "Semantic Notes", and "Comments" titles are raised one line in the Word
#     file. For some reason, when copied from the PDF, the titles are under the first item.
# 5)  Syntax notes", semantic notes, and comments titles are changed to a single paragraph 
#     (single line when converted to a text file)
# 
BEGIN {
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
	print "<!-- Copyright 2002 A4 Networks Corporation. All rights reserved. -->"
	print "<!-- The presentation, distribution or other dissemination of the information -->"
	print "<!-- contained herein by A4 Networks is not a license, either express or -->"
	print "<!-- implied, to any intellectual property owned or controlled by A4 Networks. -->"
	print "<!-- This document and the information contained herein cannot be reproduced in -->"
	print "<!-- any form or presented without the prior written consent of A4 Networks. -->"
	print "<xs:schema xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" xmlns:otl=\"http://www.a4networks.com/schemas/otl\" elementFormDefault=\"qualified\" attributeFormDefault=\"unqualified\" otl:version=\"4010\">"
	print "    <!-- Include data element definitions -->"
	print "    <xs:include schemaLocation=\"X12_4010_Composites.xsd\"/>"
	print "    <!-- X12 Segment definitions -->"
	}
/ [A-Z][A-Z0-9]{1,2}$/ {
	segmentName=$NF
	complexType="<xs:complexType name=\"sx" segmentName "\">\n<xs:sequence>"
	attrStratum="<xs:attribute name=\"stratum\" type=\"attributeStratum\" use=\"required\" fixed=\"segment\"/>"
	attrName="<xs:attribute name=\"name\" type=\"xs:string\" fixed=\"" substr($0, 1, length($0) - length($NF) - 1) "\"/>"
	getline description
	gsub(/"/, "'", description)
	attrDesc="<xs:attribute name=\"desc\" type=\"xs:string\" fixed=\"" description "\"/>"
	print complexType
	}
/^[0-9]{2} [IC0-9][0-9]{0,3}/ {
	if ($NF == "N") {
		last=NF-1
		}
	else {
		last=NF
		}
	if ($last == "M" || $last == "M/Z") {
		minOccurs=""
		}
	else {
		minOccurs="minOccurs=\"0\" "
		}
	otlNameStart=length($1) + length($2) + 3
	if ($NF == "N") {
		otlNameLength=length($0) - (otlNameStart + length($NF) + length($(NF-1)) + length($(NF-2)) + length($(NF-3)) + 3)
		}
	else {
		otlNameLength=length($0) - (otlNameStart + length($NF) + length($(NF-1)) + length($(NF-2)) + 2)
		}
print $0 "|" $1 "|" $2 "|" $3
	if (substr($2, 1, 1) == "I") {
		elementID="I" substr("000" substr($2, 2), length(substr($2, 2)) + 1, 3) 
		print "<xs:element name=\"" segmentName $1 "\" type=\"dx" elementID "\" " minOccurs "otl:name=\"" substr($0, otlNameStart, otlNameLength) "\"/>"
		}
	else {
		if (substr($2, 1, 1) == "C") {
			print "<xs:element name=\"" segmentName $1 "\" type=\"cx" $2 "\" " minOccurs "otl:name=\"" substr($0, otlNameStart, otlNameLength) "\"/>"
			}
		else {
			elementID=substr("0000" $2, length($2) + 1, 4)
			print "<xs:element name=\"" segmentName $1 "\" type=\"dx" elementID "\" " minOccurs "otl:name=\"" substr($0, otlNameStart, otlNameLength) "\"/>"
			}
		}
	}
/^$/ {
	print "</xs:sequence>"
	print attrStratum
	print attrName
	print attrDesc
	print "</xs:complexType>"
	}

END {
	print "</xs:schema>"
	}